
;*************************************************************
;* Program testujacy przyciski myszki. Po nacisnieciu lewego 
;* przycisku "zapala sie" odpowiedni punkt na ekranie. 
;* Gaszenie punktu nastepuje po nacisnieciu dowolnego klawisza
;* klawiatury. Wyjscie z programu nastepuje przez przycisniecie
;* srodkowego przycisku myszki. 
;*************************************************************

DEST   EQU 0B800H	;segment pamieci ekranu 
			;karty EGA,VGA w trybie tekstowym

;***********************************************************
CODE    SEGMENT
        ASSUME CS:CODE,DS:CODE
        ORG 100H  		; Program typu .COM

 
START:  MOV  AX,CS      
        MOV  DS,AX   		; DS <- CS;  CS = DS

        MOV  AX,DEST  		; AX <- Segment pamieci ekranu
        MOV  ES,AX    		; Inicjuj pomocniczy 
					; rejestr segmentowy


        CALL RESET_MOUSE 	; Inicjacja myszy
        CALL SHOW_MOUSE  	; Pokaz kursor

QUERY_MOUSE:
        MOV  AX,03H  		; - odczytaj parametry myszy
        INT  33H    		; /
        MOV  AX,BX     		; zachowaj BX
        AND  AX,0001H        	; czy nacisnieto lewy ?
        JNZ  LEFT_BUTTON     	; tak wiec obsluz
        MOV  AX,BX
        AND  AX,0002H   	; czy nacisnieto prawy ?
        JNZ  RIGHT_BUTTON  	; tak wic obsluz
        MOV  AX,BX
        AND  AX,0004H      	; czy nacisnieto srodkowy ?
        JNZ  FINITO      	; tak, konczymy program
        JMP  QUERY_MOUSE 	; zawracamy


FINITO: CALL HIDE_MOUSE   	; zrob porzadek z mysza
        MOV AX,4C00H         	; powrot do DOS'a
        INT 21H


; **** obsluga nacisniecia lewego przycisku

LEFT_BUTTON: MOV AL,'L'  	; parametr dla procedury INDICATE
             CALL INDICATE
             JMP QUERY_MOUSE


; **** obsluga nacisniecia prawego przycisku

RIGHT_BUTTON: MOV AL,'R' 	; parametr dla procedury INDICATE
              CALL INDICATE
              JMP QUERY_MOUSE


;**********************************************
;* Procedura realizujaca oczekiwanie na klawisz
;**********************************************
WAIT_KEY PROC NEAR
       PUSHF
       PUSH AX
       MOV AH,00H
       INT 16H
       POP AX
       POPF
       RET
ENDP

;********************************************************
;* Procedura wyswietlajaca w zaleznosci od nacisnietego 
;* przycisku podswietlona litere L lub R. Po wyswietleniu 
;* uzytkownik naciska dowolny klawisz, litera zniknie.
;* Argumenty: AL - 'R' - wyswietl prawy
;*                 'L' - wyswietl lewy
;********************************************************
INDICATE PROC NEAR
       MOV AH,70H      		; zaladuj atrybut (podswietlenie)
       CMP AL,'R'    	 	; czy prawy ?
       JE I_R         		; tak, wiec skocz do wyswietlania 
				; dla prawego
       MOV ES:[860],AX 		; wyswietl dla lewego
       JMP I_E        		; skocz do oczekiwania na klawisz
  I_R: MOV ES:[900],AX 		; wyswietl dla prawego
  I_E: CALL WAIT_KEY   		; oczekiwanie na klawisz
       MOV ES:[860],0720H 	; wymazanie z ekranu (znak spacji)
       MOV ES:[900],0720H 	; wymazanie z ekranu (znak spacji)
       RET
ENDP


;***************************************************
;* Inicjalizacja myszy
;***************************************************
RESET_MOUSE PROC NEAR
       PUSH AX
       MOV  AX,0
       INT  33H     ;reset myszy
       POP  AX
ENDP

;***************************************************
;* Pokazuje kursor myszy
;***************************************************
SHOW_MOUSE PROC NEAR
       PUSH AX
       MOV AX,1     ;pokaz kursor
       INT 33H
       POP AX
       RET
ENDP

;***************************************************
;* Schowanie kursora myszy
;***************************************************
HIDE_MOUSE PROC NEAR
       PUSH AX
       MOV AX,2    ;chowaj kursor
       INT 33H
       POP AX
       RET
ENDP


CODE ENDS
END START
